<?php
require_once 'models/Database.php';
require_once 'services/functions.php';
require_once 'services/ArticleManager.php';
require_once 'controllers/ArticleController.php';

$pdo = Database::getPdo();

$articleManager = new ArticleManager($pdo);

$routes = include 'config/route.php';



// Récupérer l'URL actuelle
$currentUrl = parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);

// Supprimer le slash initial s'il existe
$currentUrl = ltrim($currentUrl, '/');


// Vérifier si l'URL correspond à une route définie
if (array_key_exists('/' . $currentUrl, $routes)) {
    $controllerName = $routes['/' . $currentUrl]['controller'];
    $methodName = $routes['/' . $currentUrl]['method'];

    // Créer une instance du contrôleur et appeler la méthode correspondante
    $controller = new $controllerName($articleManager);
    $controller->$methodName();
} else {
    // Gérer les routes non trouvées (afficher une erreur 404 par exemple)
    header("HTTP/1.0 404 Not Found");
    echo "404 Not Found";
}
