<?php
require_once dirname(__DIR__).'/models/database.php';
require_once dirname(__DIR__).'/services/ArticleManager.php';

class ArticleForm
{

    public $title;
    public $content;
    public $created_at;
    public $id;

    public $errors = [];

    public function __construct(array $data = [])
    {
        $this->hydrater($data);
    }

    public function hydrater(array $data)
    {
        foreach ($data as $key => $value) {
            $this->$key = $value;
        }
    }

    public function isValid()
    {
        $champsObligatoires = ['title', 'content', 'created_at'];

        foreach ($champsObligatoires as $champ) {
            if (empty($this->$champ)) {
                $this->errors[$champ] = "Le champ $champ est obligatoire";
            }
        }

        return empty($this->errors);
    }

    public function create(ArticleManager $articleManager)
    {
        if ($this->isValid()) {
            $articleManager->create($this->getData());
            return true;
        }
        return false;
    }
    public function update(int $id, ArticleManager $articleManager)
    {

        if ($this->isValid()) {
            $articleManager->update($id, $this->getData());
            return true;
        }
        return false;
    }



    public function getData()
    {
        return new Article(
            $this->title,
            $this->content,
            $this->created_at,
            $this->id ?? 0,
        );
    }

    public function getErrors()
    {
        return $this->errors;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getContent()
    {
        return $this->content;
    }

    public function getCreated_at()
    {
        return $this->created_at;
    }

}